<template>
    <div class="row">
        <!-- Start col -->
        <div class="col-md-12 col-lg-12 col-xl-12">
            <div class="card m-b-30">
                <div class="card-body">
                    <div class="row">
                        <div class="col-lg-6 col-xl-5">
                            <div class="product-slider-box product-box-for">
                                <div class="product-preview">
                                    <img
                                        :src="curso.feature_image"
                                        class="img-fluid"
                                        alt="Product"
                                    />
                                    <p>
                                        <span
                                            class="badge badge-success font-14"
                                            >25% off</span
                                        >
                                    </p>
                                </div>

                                <div
                                    v-if="curso.gallery"
                                    class="product-preview"
                                >
                                    <img
                                        src=""
                                        class="img-fluid"
                                        alt="Product"
                                    />
                                    <p>
                                        <span
                                            class="badge badge-primary font-14"
                                            >New</span
                                        >
                                    </p>
                                </div>
                            </div>
                            <div class="product-slider-box product-box-nav">
                                <div class="product-preview">
                                    <img
                                        :src="curso.feature_image"
                                        class="img-fluid"
                                        alt="Product"
                                    />
                                </div>

                                <div
                                    v-if="curso.gallery"
                                    class="product-preview"
                                >
                                    <img
                                        src=""
                                        class="img-fluid"
                                        alt="Product"
                                    />
                                </div>
                            </div>
                        </div>
                        <div class="col-lg-6 col-xl-7">
                            <p>
                                <span class="badge badge-light font-16">{{
                                    curso.categorias.name
                                }}</span>
                            </p>
                            <h2 class="font-22">{{ curso.title }}</h2>

                            <p class="text-primary font-26 f-w-7 my-3">
                                <sup v-if="curso.price_sale" class="font-16"
                                    >$</sup
                                >{{ curso.price_sale ? curso.price_sale : "" }}
                                <span
                                    :class="
                                        curso.price_sale
                                            ? 'text-danger descount'
                                            : ''
                                    "
                                    ><sup class="font-16">$</sup
                                    >{{ curso.price }}</span
                                >
                            </p>
                            <div class="button-list mt-5 mb-5">
                                <button
                                    type="button"
                                    v-on:click.prevent="
                                        wishlist
                                            ? agregarWishlist()
                                            : quitarWishlist()
                                    "
                                    :class="
                                        wishlist
                                            ? 'btn btn-danger-rgba font-18'
                                            : 'btn btn-primary-rgba font-18'
                                    "
                                >
                                    <i class="feather icon-heart"></i>
                                </button>
                                <button
                                    v-if="!planilla"
                                    type="button"
                                    class="btn btn-danger-rgba font-18"
                                    v-on:click.prevent="quitarCarrito()"
                                >
                                    <i
                                        class="feather icon-shopping-bag mr-2"
                                    ></i
                                    >Quitar de la planilla de inscripción
                                </button>
                                <button
                                    v-if="planilla"
                                    type="button"
                                    class="btn btn-primary-rgba font-18"
                                    v-on:click.prevent="agregarCarrito()"
                                >
                                    <i
                                        class="feather icon-shopping-bag mr-2"
                                    ></i
                                    >Agregar a planilla de inscripción
                                </button>
                                <a
                                    v-if="!planilla"
                                    type="button"
                                    class="btn btn-success font-17"
                                    href="/cart"
                                >
                                    Ver planilla de inscripción
                                </a>
                                <button
                                    v-if="!user && !inscribir"
                                    type="button"
                                    class="btn btn-success font-17"
                                    @click.prevent="inscribir = true"
                                >
                                    <i class="feather icon-bookmark mr-2"></i>
                                    Incribirse
                                </button>
                            </div>

                            <template v-if="login">
                                <front-curso-first-auth-login-row-component
                                    :token="csrf"
                                    :login="rutaLogin"
                                    @saveFormat="agregarCarrito"
                                ></front-curso-first-auth-login-row-component>
                                <p class="mb-0 mt-3">
                                    ¿No estás inscrito aún?
                                    <a
                                        href="javascript:void(0);"
                                        @click.prevent="login = null"
                                        >Regístrate</a
                                    >
                                </p>
                            </template>
                            <template v-if="!user && !login && inscribir">
                                <front-curso-first-auth-register-row-component
                                    :token="csrf"
                                    :registro="rutaRegister"
                                    @saveFormat="agregarCarrito"
                                ></front-curso-first-auth-register-row-component>
                                <p class="mb-0 mt-3">
                                    ¿Ya posee una cuenta en Megalca Academy?
                                    <a
                                        href="javascript:void(0);"
                                        @click.prevent="login = true"
                                        >Iniciar sesión</a
                                    >
                                </p>
                            </template>

                            <div class="button-list">
                                <h6 class="mb-3">
                                    Comparte este curso:
                                </h6>

                                <a
                                    :href="
                                        'https://www.facebook.com/sharer/sharer.php?u=' +
                                            url
                                    "
                                    class="btn btn-primary-rgba font-18"
                                    ><i class="feather icon-facebook"></i
                                ></a>
                                <a
                                    :href="
                                        'https://twitter.com/home?status=' + url
                                    "
                                    class="btn btn-info-rgba font-18"
                                    ><i class="feather icon-twitter"></i
                                ></a>
                                <a
                                    :href="
                                        'https://www.linkedin.com/shareArticle?mini=true&url=' +
                                            url
                                    "
                                    class="btn btn-warning-rgba font-18"
                                    ><i class="feather icon-linkedin"></i
                                ></a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- End col -->
    </div>
</template>

<script>
export default {
    props: ["cursos", "user", "token", "iniciar", "registro"],
    mounted() {
        console.log(this.token);
        this.reviewCurso();
        this.reviewWishlist();
    },
    data() {
        return {
            csrf: this.token,
            rutaLogin: this.iniciar,
            rutaRegister: this.registro,
            curso: this.cursos,
            url: location.href,
            planilla: true,
            wishlist: true,
            users: this.user,
            login: null,
            inscribir: null
        };
    },
    methods: {
        reviewCurso() {
            let curso = localStorage.getItem("car");
            if (curso) {
                curso = JSON.parse(curso);
                let i = 0;
                while (i < curso.length) {
                    if (curso[i].id == this.curso.id) {
                        this.planilla = false;
                    }
                    i++;
                }
            }
        },
        reviewWishlist() {
            let curso = localStorage.getItem("wishlist");
            if (curso) {
                curso = JSON.parse(curso);
                let i = 0;
                while (i < curso.length) {
                    if (curso[i].id == this.curso.id) {
                        this.wishlist = false;
                    }
                    i++;
                }
            }
        },
        agregarCarrito() {
            let shop = [];
            let curso;
            shop = localStorage.getItem("car");
            if (this.curso.price_sale) {
                curso = [
                    {
                        title: this.curso.title,
                        price: this.curso.price_sale,
                        image: this.curso.feature_image,
                        id: this.curso.id
                    }
                ];
            } else {
                curso = [
                    {
                        title: this.curso.title,
                        price: this.curso.price,
                        image: this.curso.feature_image,
                        id: this.curso.id
                    }
                ];
            }

            if (!shop) {
                localStorage.setItem("car", JSON.stringify(curso));
                this.planilla = false;
            } else {
                if (this.curso.price_sale) {
                    curso = {
                        title: this.curso.title,
                        price: this.curso.price_sale,
                        image: this.curso.feature_image,
                        id: this.curso.id
                    };
                } else {
                    curso = {
                        title: this.curso.title,
                        price: this.curso.price,
                        image: this.curso.feature_image,
                        id: this.curso.id
                    };
                }

                shop = JSON.parse(shop);
                shop.push(curso);
                localStorage.setItem("car", JSON.stringify(shop));
                this.planilla = false;
                this.$emit("verifycar");
            }
        },
        quitarCarrito() {
            let shop = [];
            let curso = JSON.parse(localStorage.getItem("car"));
            curso = curso.filter(e => e.id != this.curso.id);
            localStorage.setItem("car", JSON.stringify(curso));
            this.planilla = true;
            this.$emit("verifycar");
        },
        agregarWishlist() {
            let shop = [];
            shop = localStorage.getItem("wishlist");
            let curso = [
                {
                    title: this.curso.title,
                    price: this.curso.price,
                    image: this.curso.feature_image,
                    id: this.curso.id
                }
            ];
            if (!shop) {
                localStorage.setItem("wishlist", JSON.stringify(curso));
                this.wishlist = false;
            } else {
                curso = {
                    title: this.curso.title,
                    price: this.curso.price,
                    image: this.curso.feature_image,
                    id: this.curso.id
                };
                shop = JSON.parse(shop);
                shop.push(curso);
                localStorage.setItem("wishlist", JSON.stringify(shop));
                this.wishlist = false;
            }
        },
        quitarWishlist() {
            let shop = [];
            let curso = JSON.parse(localStorage.getItem("wishlist"));
            curso = curso.filter(e => e.id != this.curso.id);
            localStorage.setItem("wishlist", JSON.stringify(curso));
            this.wishlist = true;
        },
        inscribirse() {
            if (this.users) {
                sessionStorage.clear();

                sessionStorage.setItem(
                    "inscripcion",
                    JSON.stringify(this.curso)
                );
                location.href = "/checkout";
            } else {
                location.href =
                    location.origin + "/register?redirect_to=" + location.href;
            }
        }
    }
};
</script>
